(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react/jsx-runtime'), require('react'), require('rdk'), require('framer-motion'), require('react-use-gesture'), require('elkjs/lib/elk.bundled'), require('p-cancelable'), require('calculate-size'), require('ellipsize'), require('react-cool-dimensions'), require('react-fast-compare'), require('kld-affine'), require('classnames'), require('d3-shape'), require('reakeys'), require('undoo'), require('kld-intersections')) :
    typeof define === 'function' && define.amd ? define(['exports', 'react/jsx-runtime', 'react', 'rdk', 'framer-motion', 'react-use-gesture', 'elkjs/lib/elk.bundled', 'p-cancelable', 'calculate-size', 'ellipsize', 'react-cool-dimensions', 'react-fast-compare', 'kld-affine', 'classnames', 'd3-shape', 'reakeys', 'undoo', 'kld-intersections'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.reaflow = {}, global.jsxRuntime, global.react, global.rdk, global.framerMotion, global.reactUseGesture, global.ELK, global.PCancelable, global.calculateSize, global.ellipsize, global.useDimensions, global.isEqual, global.kldAffine, global.classNames, global.d3Shape, global.reakeys, global.Undoo, global.kldIntersections));
}(this, (function (exports, jsxRuntime, react, rdk, framerMotion, reactUseGesture, ELK, PCancelable, calculateSize, ellipsize, useDimensions, isEqual, kldAffine, classNames, d3Shape, reakeys, Undoo, kldIntersections) {
    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var ELK__default = /*#__PURE__*/_interopDefaultLegacy(ELK);
    var PCancelable__default = /*#__PURE__*/_interopDefaultLegacy(PCancelable);
    var calculateSize__default = /*#__PURE__*/_interopDefaultLegacy(calculateSize);
    var ellipsize__default = /*#__PURE__*/_interopDefaultLegacy(ellipsize);
    var useDimensions__default = /*#__PURE__*/_interopDefaultLegacy(useDimensions);
    var isEqual__default = /*#__PURE__*/_interopDefaultLegacy(isEqual);
    var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);
    var Undoo__default = /*#__PURE__*/_interopDefaultLegacy(Undoo);

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    const MAX_CHAR_COUNT = 35;
    const MIN_NODE_WIDTH = 50;
    const DEFAULT_NODE_HEIGHT = 50;
    const NODE_PADDING = 30;
    const ICON_PADDING = 10;
    function measureText(text) {
        let result = { height: 0, width: 0 };
        if (text) {
            result = calculateSize__default['default'](text, {
                font: 'Arial, sans-serif',
                fontSize: '14px'
            });
        }
        return result;
    }
    function parsePadding(padding) {
        let top = 50;
        let right = 50;
        let bottom = 50;
        let left = 50;
        if (Array.isArray(padding)) {
            if (padding.length === 2) {
                top = padding[0];
                bottom = padding[0];
                left = padding[1];
                right = padding[1];
            }
            else if (padding.length === 4) {
                top = padding[0];
                right = padding[1];
                bottom = padding[2];
                left = padding[3];
            }
        }
        else if (padding !== undefined) {
            top = padding;
            right = padding;
            bottom = padding;
            left = padding;
        }
        return {
            top,
            right,
            bottom,
            left
        };
    }
    function formatText(node) {
        const text = node.text ? ellipsize__default['default'](node.text, MAX_CHAR_COUNT) : node.text;
        const labelDim = measureText(text);
        const nodePadding = parsePadding(node.nodePadding);
        let width = node.width;
        if (width === undefined) {
            if (text && node.icon) {
                width = labelDim.width + node.icon.width + NODE_PADDING + ICON_PADDING;
            }
            else {
                if (text) {
                    width = labelDim.width + NODE_PADDING;
                }
                else if (node.icon) {
                    width = node.icon.width + NODE_PADDING;
                }
                width = Math.max(width, MIN_NODE_WIDTH);
            }
        }
        let height = node.height;
        if (height === undefined) {
            if (text && node.icon) {
                height = labelDim.height + node.icon.height;
            }
            else if (text) {
                height = labelDim.height + NODE_PADDING;
            }
            else if (node.icon) {
                height = node.icon.height + NODE_PADDING;
            }
            height = Math.max(height, DEFAULT_NODE_HEIGHT);
        }
        return {
            text,
            originalText: node.text,
            width,
            height,
            nodePadding,
            labelHeight: labelDim.height,
            labelWidth: labelDim.width
        };
    }

    /**
     * ELK layout options applied by default, unless overridden through <Canvas layoutOptions> property.
     *
     * XXX Not to be confounded with ELK "defaultLayoutOptions" property, which is meant to be used as fallback, when no layout option is provided.
     *
     * @see https://www.eclipse.org/elk/reference/options.html
     */
    const defaultLayoutOptions = {
        /**
         * Hints for where node labels are to be placed; if empty, the node label’s position is not modified.
         *
         * @see https://www.eclipse.org/elk/reference/options/org-eclipse-elk-nodeLabels-placement.html
         */
        'elk.nodeLabels.placement': 'INSIDE V_CENTER H_RIGHT',
        /**
         * Select a specific layout algorithm.
         *
         * Uses "layered" strategy.
         * It emphasizes the direction of edges by pointing as many edges as possible into the same direction.
         * The nodes are arranged in layers, which are sometimes called “hierarchies”,
         * and then reordered such that the number of edge crossings is minimized.
         * Afterwards, concrete coordinates are computed for the nodes and edge bend points.
         *
         * @see https://www.eclipse.org/elk/reference/algorithms.html
         * @see https://www.eclipse.org/elk/reference/options/org-eclipse-elk-algorithm.html
         * @see https://www.eclipse.org/elk/reference/algorithms/org-eclipse-elk-layered.html
         */
        'elk.algorithm': 'org.eclipse.elk.layered',
        /**
         * Overall direction of edges: horizontal (right / left) or vertical (down / up).
         *
         * @see https://www.eclipse.org/elk/reference/options/org-eclipse-elk-direction.html
         */
        'elk.direction': 'DOWN',
        /**
         * Strategy for node layering.
         *
         * @see https://www.eclipse.org/elk/reference/options/org-eclipse-elk-layered-layering-strategy.html
         */
        'org.eclipse.elk.layered.layering.strategy': 'INTERACTIVE',
        /**
         * What kind of edge routing style should be applied for the content of a parent node.
         * Algorithms may also set this option to single edges in order to mark them as splines.
         * The bend point list of edges with this option set to SPLINES
         * must be interpreted as control points for a piecewise cubic spline.
         *
         * @see https://www.eclipse.org/elk/reference/options/org-eclipse-elk-edgeRouting.html
         */
        'org.eclipse.elk.edgeRouting': 'ORTHOGONAL',
        /**
         * Adds bend points even if an edge does not change direction.
         * If true, each long edge dummy will contribute a bend point to its edges
         * and hierarchy-crossing edges will always get a bend point where they cross hierarchy boundaries.
         * By default, bend points are only added where an edge changes direction.
         *
         * @see https://www.eclipse.org/elk/reference/options/org-eclipse-elk-layered-unnecessaryBendpoints.html
         */
        'elk.layered.unnecessaryBendpoints': 'true',
        /**
         * The spacing to be preserved between nodes and edges that are routed next to the node’s layer.
         * For the spacing between nodes and edges that cross the node’s layer ‘spacing.edgeNode’ is used.
         *
         * @see https://www.eclipse.org/elk/reference/options/org-eclipse-elk-layered-spacing-edgeNodeBetweenLayers.html
         */
        'elk.layered.spacing.edgeNodeBetweenLayers': '50',
        /**
         * Tells the BK node placer to use a certain alignment (out of its four)
         * instead of the one producing the smallest height, or the combination of all four.
         *
         * @see https://www.eclipse.org/elk/reference/options/org-eclipse-elk-layered-nodePlacement-bk-fixedAlignment.html
         */
        'org.eclipse.elk.layered.nodePlacement.bk.fixedAlignment': 'BALANCED',
        /**
         * Strategy for cycle breaking.
         *
         * Cycle breaking looks for cycles in the graph and determines which edges to reverse to break the cycles.
         * Reversed edges will end up pointing to the opposite direction of regular edges
         * (that is, reversed edges will point left if edges usually point right).
         *
         * @see https://www.eclipse.org/elk/reference/options/org-eclipse-elk-layered-cycleBreaking-strategy.html
         */
        'org.eclipse.elk.layered.cycleBreaking.strategy': 'DEPTH_FIRST',
        /**
         * Whether this node allows to route self loops inside of it instead of around it.
         *
         * If set to true, this will make the node a compound node if it isn’t already,
         * and will require the layout algorithm to support compound nodes with hierarchical ports.
         *
         * @see https://www.eclipse.org/elk/reference/options/org-eclipse-elk-insideSelfLoops-activate.html
         */
        'org.eclipse.elk.insideSelfLoops.activate': 'true',
        /**
         * Whether each connected component should be processed separately.
         *
         * @see https://www.eclipse.org/elk/reference/options/org-eclipse-elk-separateConnectedComponents.html
         */
        separateConnectedComponents: 'false',
        /**
         * Spacing to be preserved between pairs of connected components.
         * This option is only relevant if ‘separateConnectedComponents’ is activated.
         *
         * @see https://www.eclipse.org/elk/reference/options/org-eclipse-elk-spacing-componentComponent.html
         */
        'spacing.componentComponent': '70',
        /**
         * TODO: Should be spacing.baseValue?
         * An optional base value for all other layout options of the ‘spacing’ group.
         * It can be used to conveniently alter the overall ‘spaciousness’ of the drawing.
         * Whenever an explicit value is set for the other layout options, this base value will have no effect.
         * The base value is not inherited, i.e. it must be set for each hierarchical node.
         *
         * @see https://www.eclipse.org/elk/reference/groups/org-eclipse-elk-layered-spacing.html
         */
        spacing: '75',
        /**
         * The spacing to be preserved between any pair of nodes of two adjacent layers.
         * Note that ‘spacing.nodeNode’ is used for the spacing between nodes within the layer itself.
         *
         * @see https://www.eclipse.org/elk/reference/options/org-eclipse-elk-layered-spacing-nodeNodeBetweenLayers.html
         */
        'spacing.nodeNodeBetweenLayers': '70'
    };
    function mapNode(nodes, edges, node) {
        const { text, width, height, labelHeight, labelWidth, nodePadding, originalText } = formatText(node);
        const children = nodes
            .filter((n) => n.parent === node.id)
            .map((n) => mapNode(nodes, edges, n));
        const childEdges = edges
            .filter((e) => e.parent === node.id)
            .map((e) => mapEdge(e));
        const nodeLayoutOptions = Object.assign({ 'elk.padding': `[left=${nodePadding.left}, top=${nodePadding.top}, right=${nodePadding.right}, bottom=${nodePadding.bottom}]`, portConstraints: 'FIXED_ORDER' }, (node.layoutOptions || {}));
        return {
            id: node.id,
            height,
            width,
            children,
            edges: childEdges,
            ports: node.ports
                ? node.ports.map((port) => ({
                    id: port.id,
                    properties: Object.assign(Object.assign({}, port), { 'port.side': port.side, 'port.alignment': port.alignment || 'CENTER' })
                }))
                : [],
            layoutOptions: nodeLayoutOptions,
            properties: Object.assign({}, node),
            labels: text
                ? [
                    {
                        width: labelWidth,
                        height: -(labelHeight / 2),
                        text,
                        originalText
                        // layoutOptions: { 'elk.nodeLabels.placement': 'INSIDE V_CENTER H_CENTER' }
                    }
                ]
                : []
        };
    }
    function mapEdge(_a) {
        var { data } = _a, edge = __rest(_a, ["data"]);
        const labelDim = measureText(edge.text);
        const validEdgeData = data ? { data } : {};
        return Object.assign(Object.assign({ id: edge.id, source: edge.from, target: edge.to, properties: Object.assign({}, edge) }, validEdgeData), { sourcePort: edge.fromPort, targetPort: edge.toPort, labels: edge.text
                ? [
                    {
                        width: labelDim.width / 2,
                        height: -(labelDim.height / 2),
                        text: edge.text,
                        layoutOptions: {
                            'elk.edgeLabels.placement': 'INSIDE V_CENTER H_CENTER'
                        }
                    }
                ]
                : [] });
    }
    function mapInput(nodes, edges) {
        const children = [];
        const mappedEdges = [];
        for (const node of nodes) {
            if (!node.parent) {
                const mappedNode = mapNode(nodes, edges, node);
                if (mappedNode !== null) {
                    children.push(mappedNode);
                }
            }
        }
        for (const edge of edges) {
            if (!edge.parent) {
                const mappedEdge = mapEdge(edge);
                if (mappedEdge !== null) {
                    mappedEdges.push(mappedEdge);
                }
            }
        }
        return {
            children,
            edges: mappedEdges
        };
    }
    function postProcessNode(nodes) {
        var _a;
        for (const node of nodes) {
            const hasLabels = ((_a = node.labels) === null || _a === void 0 ? void 0 : _a.length) > 0;
            if (hasLabels && node.properties.icon) {
                const [label] = node.labels;
                label.x = node.properties.icon.width + 25;
                node.properties.icon.x = 25;
                node.properties.icon.y = node.height / 2;
            }
            else if (hasLabels) {
                const [label] = node.labels;
                label.x = (node.width - label.width) / 2;
            }
            else if (node.properties.icon) {
                node.properties.icon.x = node.width / 2;
                node.properties.icon.y = node.height / 2;
            }
            if (node.children) {
                postProcessNode(node.children);
            }
        }
        return nodes;
    }
    const elkLayout = (nodes, edges, options) => {
        const graph = new ELK__default['default']();
        const layoutOptions = Object.assign(Object.assign({}, defaultLayoutOptions), options);
        return new PCancelable__default['default']((resolve, reject) => {
            graph
                .layout(Object.assign({ id: 'root' }, mapInput(nodes, edges)), {
                layoutOptions: layoutOptions
            })
                .then((data) => {
                resolve(Object.assign(Object.assign({}, data), { children: postProcessNode(data.children) }));
            })
                .catch(reject);
        });
    };

    (function (CanvasPosition) {
        CanvasPosition["CENTER"] = "center";
        CanvasPosition["TOP"] = "top";
        CanvasPosition["LEFT"] = "left";
        CanvasPosition["RIGHT"] = "right";
        CanvasPosition["BOTTOM"] = "bottom";
    })(exports.CanvasPosition || (exports.CanvasPosition = {}));

    const useLayout = ({ maxWidth, maxHeight, nodes = [], edges = [], fit, pannable, defaultPosition, direction, layoutOptions = {}, zoom, setZoom, onLayoutChange }) => {
        const scrolled = react.useRef(false);
        const ref = react.useRef();
        const { observe, width, height } = useDimensions__default['default']();
        const [layout, setLayout] = react.useState(null);
        const [xy, setXY] = react.useState([0, 0]);
        const [scrollXY, setScrollXY] = react.useState([0, 0]);
        const canvasHeight = pannable ? maxHeight : height;
        const canvasWidth = pannable ? maxWidth : width;
        react.useEffect(() => {
            const promise = elkLayout(nodes, edges, Object.assign({ 'elk.direction': direction }, layoutOptions));
            promise
                .then(result => {
                if (!isEqual__default['default'](layout, result)) {
                    setLayout(result);
                    onLayoutChange(result);
                }
            })
                .catch(err => {
                if (err.name !== 'CancelError') {
                    console.error('Layout Error:', err);
                }
            });
            return () => promise.cancel();
            // eslint-disable-next-line react-hooks/exhaustive-deps
        }, [nodes, edges]);
        const positionVector = react.useCallback((position) => {
            if (layout) {
                const centerX = (canvasWidth - layout.width * zoom) / 2;
                const centerY = (canvasHeight - layout.height * zoom) / 2;
                switch (position) {
                    case exports.CanvasPosition.CENTER:
                        setXY([centerX, centerY]);
                        break;
                    case exports.CanvasPosition.TOP:
                        setXY([centerX, 0]);
                        break;
                    case exports.CanvasPosition.LEFT:
                        setXY([0, centerY]);
                        break;
                    case exports.CanvasPosition.RIGHT:
                        setXY([canvasWidth - layout.width * zoom, centerY]);
                        break;
                    case exports.CanvasPosition.BOTTOM:
                        setXY([centerX, canvasHeight - layout.height * zoom]);
                        break;
                }
            }
        }, [canvasWidth, canvasHeight, layout, zoom]);
        const positionScroll = react.useCallback((position) => {
            const scrollCenterX = (canvasWidth - width) / 2;
            const scrollCenterY = (canvasHeight - height) / 2;
            if (pannable) {
                switch (position) {
                    case exports.CanvasPosition.CENTER:
                        setScrollXY([scrollCenterX, scrollCenterY]);
                        break;
                    case exports.CanvasPosition.TOP:
                        setScrollXY([scrollCenterX, 0]);
                        break;
                    case exports.CanvasPosition.LEFT:
                        setScrollXY([0, scrollCenterY]);
                        break;
                    case exports.CanvasPosition.RIGHT:
                        setScrollXY([canvasWidth - width, scrollCenterY]);
                        break;
                    case exports.CanvasPosition.BOTTOM:
                        setScrollXY([scrollCenterX, canvasHeight - height]);
                        break;
                }
            }
        }, [canvasWidth, canvasHeight, width, height, pannable]);
        const positionCanvas = react.useCallback((position) => {
            positionVector(position);
            positionScroll(position);
        }, [positionScroll, positionVector]);
        react.useEffect(() => {
            var _a;
            (_a = ref === null || ref === void 0 ? void 0 : ref.current) === null || _a === void 0 ? void 0 : _a.scrollTo(scrollXY[0], scrollXY[1]);
        }, [scrollXY, ref]);
        react.useEffect(() => {
            if (scrolled.current && defaultPosition) {
                positionVector(defaultPosition);
            }
        }, [positionVector, zoom, defaultPosition]);
        const fitCanvas = react.useCallback(() => {
            if (layout) {
                const heightZoom = height / layout.height;
                const widthZoom = width / layout.width;
                const scale = Math.min(heightZoom, widthZoom, 1);
                setZoom(scale - 1);
                positionCanvas(exports.CanvasPosition.CENTER);
            }
        }, [height, layout, width, setZoom, positionCanvas]);
        react.useLayoutEffect(() => {
            const scroller = ref.current;
            if (scroller && !scrolled.current && layout && height && width) {
                if (fit) {
                    fitCanvas();
                }
                else if (defaultPosition) {
                    positionCanvas(defaultPosition);
                }
                scrolled.current = true;
            }
        }, [
            canvasWidth,
            pannable,
            canvasHeight,
            layout,
            height,
            fit,
            width,
            defaultPosition,
            positionCanvas,
            fitCanvas,
            ref
        ]);
        react.useLayoutEffect(() => {
            function onResize() {
                if (fit) {
                    fitCanvas();
                }
                else if (defaultPosition) {
                    positionCanvas(defaultPosition);
                }
            }
            window.addEventListener('resize', onResize);
            return () => window.removeEventListener('resize', onResize);
        }, [fit, positionCanvas, defaultPosition, fitCanvas]);
        return {
            xy,
            observe,
            containerRef: ref,
            canvasHeight,
            canvasWidth,
            containerWidth: width,
            containerHeight: height,
            layout,
            scrollXY,
            positionCanvas,
            fitCanvas,
            setScrollXY
        };
    };

    const useEdgeDrag = ({ onNodeLink, onNodeLinkCheck }) => {
        const [dragNode, setDragNode] = react.useState(null);
        const [dragPort, setDragPort] = react.useState(null);
        const [dragType, setDragType] = react.useState(null);
        const [enteredNode, setEnteredNode] = react.useState(null);
        const [dragCoords, setDragCoords] = react.useState(null);
        const [canLinkNode, setCanLinkNode] = react.useState(null);
        const onDragStart = react.useCallback((state, _initial, node, port) => {
            setDragType(state.dragType);
            setDragNode(node);
            setDragPort(port);
        }, []);
        const onDrag = react.useCallback(({ memo: [matrix], xy: [x, y] }, [ix, iy]) => {
            const endPoint = new kldAffine.Point2D(x, y).transform(matrix);
            setDragCoords([
                {
                    startPoint: {
                        x: ix,
                        y: iy
                    },
                    endPoint
                }
            ]);
        }, []);
        const onDragEnd = react.useCallback((event) => {
            if (dragNode && enteredNode && canLinkNode) {
                onNodeLink(event, dragNode, enteredNode, dragPort);
            }
            setDragNode(null);
            setDragPort(null);
            setEnteredNode(null);
            setDragCoords(null);
        }, [canLinkNode, dragNode, dragPort, enteredNode, onNodeLink]);
        const onEnter = react.useCallback((event, node) => {
            if (dragNode && node) {
                setEnteredNode(node);
                const canLink = onNodeLinkCheck(event, dragNode, node, dragPort);
                const result = (canLink === undefined || canLink) &&
                    (dragNode.parent === node.parent || dragType === 'node');
                setCanLinkNode(result);
            }
        }, [dragNode, dragPort, dragType, onNodeLinkCheck]);
        const onLeave = react.useCallback((event, node) => {
            if (dragNode && node) {
                setEnteredNode(null);
                setCanLinkNode(null);
            }
        }, [dragNode]);
        return {
            dragCoords,
            canLinkNode,
            dragNode,
            dragPort,
            enteredNode,
            onDragStart,
            onDrag,
            onDragEnd,
            onEnter,
            onLeave
        };
    };

    const limit = (scale, min, max) => scale < max ? (scale > min ? scale : min) : max;
    const useZoom = ({ disabled = false, zoom = 1, minZoom = -0.5, maxZoom = 1, onZoomChange }) => {
        const [factor, setFactor] = react.useState(zoom - 1);
        const svgRef = react.useRef(null);
        reactUseGesture.useGesture({
            onPinch: ({ offset: [d], event }) => {
                event.preventDefault();
                // TODO: Set X/Y on center of zoom
                const next = limit(d / 100, minZoom, maxZoom);
                setFactor(next);
                onZoomChange(next + 1);
            }
        }, {
            enabled: !disabled,
            domTarget: svgRef,
            eventOptions: { passive: false }
        });
        const setZoom = react.useCallback((f) => {
            const next = limit(f, minZoom, maxZoom);
            setFactor(next);
            onZoomChange(next + 1);
        }, [maxZoom, minZoom, onZoomChange]);
        const zoomIn = react.useCallback(() => {
            setZoom(factor + 0.1);
        }, [factor, setZoom]);
        const zoomOut = react.useCallback(() => {
            setZoom(factor - 0.1);
        }, [factor, setZoom]);
        return {
            svgRef,
            zoom: factor + 1,
            setZoom,
            zoomIn,
            zoomOut
        };
    };

    const CanvasContext = react.createContext({});
    const CanvasProvider = ({ selections, onNodeLink, readonly, children, nodes, edges, maxHeight, fit, maxWidth, direction, layoutOptions, pannable, defaultPosition, zoomable, zoom, minZoom, maxZoom, onNodeLinkCheck, onLayoutChange, onZoomChange }) => {
        const zoomProps = useZoom({
            zoom,
            minZoom,
            maxZoom,
            disabled: !zoomable,
            onZoomChange
        });
        const layoutProps = useLayout({
            nodes,
            edges,
            maxHeight,
            maxWidth,
            direction,
            pannable,
            defaultPosition,
            fit,
            layoutOptions,
            zoom: zoomProps.zoom,
            setZoom: zoomProps.setZoom,
            onLayoutChange
        });
        const dragProps = useEdgeDrag({
            onNodeLink,
            onNodeLinkCheck
        });
        return (jsxRuntime.jsx(CanvasContext.Provider, Object.assign({ value: Object.assign(Object.assign(Object.assign({ selections,
                readonly,
                pannable }, layoutProps), zoomProps), dragProps) }, { children: children }), void 0));
    };
    const useCanvas = () => {
        const context = react.useContext(CanvasContext);
        if (context === undefined) {
            throw new Error('`useCanvas` hook must be used within a `CanvasContext` component');
        }
        return context;
    };

    /**
     * Checks if the node can be linked or not.
     */
    function checkNodeLinkable(curNode, enteredNode, canLinkNode) {
        if (canLinkNode === null || !enteredNode) {
            return null;
        }
        if (!enteredNode || !curNode) {
            return false;
        }
        // TODO: Revisit how to do self-linking better...
        if (canLinkNode === false && enteredNode.id === curNode.id) {
            return false;
        }
        return true;
    }
    /**
     * Given various dimensions and positions, create a matrix
     * used for determining position.
     */
    function getCoords({ zoom, layoutXY, containerRef }) {
        const { top, left } = containerRef.current.getBoundingClientRect();
        const tx = layoutXY[0] - containerRef.current.scrollLeft + left;
        const ty = layoutXY[1] - containerRef.current.scrollTop + top;
        return new kldAffine.Matrix2D().translate(tx, ty).scale(zoom).inverse();
    }
    /**
     * Given a nodeId to find, a list of nodes to check against, and an optional parentId of the node
     * find the node from the list of nodes
     */
    function findNestedNode(nodeId, children, parentId) {
        if (!nodeId || !children) {
            return {};
        }
        const foundNode = children.find(n => n.id === nodeId);
        if (foundNode) {
            return foundNode;
        }
        if (parentId) {
            const parentNode = children.find(n => n.id === parentId);
            if (parentNode === null || parentNode === void 0 ? void 0 : parentNode.children) {
                return findNestedNode(nodeId, parentNode.children, parentId);
            }
        }
        // Check for nested children
        const nodesWithChildren = children.filter(n => { var _a; return (_a = n.children) === null || _a === void 0 ? void 0 : _a.length; });
        // Iterate over all nested nodes and check if any of them contain the node
        for (const n of nodesWithChildren) {
            const foundChild = findNestedNode(nodeId, n.children, parentId);
            if (foundChild && Object.keys(foundChild).length) {
                return foundChild;
            }
        }
        return {};
    }
    /**
     * Return the layout node that is currently being dragged on the Canvas
     */
    function getDragNodeData(dragNode, children = []) {
        if (!dragNode) {
            return {};
        }
        const { parent } = dragNode;
        if (!parent) {
            return (children === null || children === void 0 ? void 0 : children.find(n => n.id === dragNode.id)) || {};
        }
        return findNestedNode(dragNode.id, children, parent);
    }

    const useNodeDrag = ({ x, y, height, width, onDrag, onDragEnd, onDragStart, node, disabled }) => {
        const initial = [width / 2 + x, height + y];
        const targetRef = react.useRef(null);
        const { zoom, xy, containerRef } = useCanvas();
        const bind = reactUseGesture.useDrag(state => {
            if (state.event.type === 'pointerdown') {
                targetRef.current = state.event.currentTarget;
            }
            if (!state.intentional || !targetRef.current) {
                return;
            }
            if (state.first) {
                const matrix = getCoords({
                    containerRef,
                    zoom,
                    layoutXY: xy
                });
                // memo will hold the difference between the
                // first point of impact and the origin
                const memo = [matrix];
                onDragStart(Object.assign(Object.assign({}, state), { memo }), initial, node);
                return memo;
            }
            onDrag(state, initial, node);
            if (state.last) {
                targetRef.current = null;
                onDragEnd(state, initial, node);
            }
        }, {
            enabled: !disabled,
            triggerAllEvents: true,
            threshold: 5
        });
        return bind;
    };

    function styleInject(css, ref) {
      if ( ref === void 0 ) ref = {};
      var insertAt = ref.insertAt;

      if (!css || typeof document === 'undefined') { return; }

      var head = document.head || document.getElementsByTagName('head')[0];
      var style = document.createElement('style');
      style.type = 'text/css';

      if (insertAt === 'top') {
        if (head.firstChild) {
          head.insertBefore(style, head.firstChild);
        } else {
          head.appendChild(style);
        }
      } else {
        head.appendChild(style);
      }

      if (style.styleSheet) {
        style.styleSheet.cssText = css;
      } else {
        style.appendChild(document.createTextNode(css));
      }
    }

    var css_248z = ".Port-module_port__30o1q {\n  stroke: #0d0e17;\n  fill: #3e405a;\n  stroke-width: 2px;\n  shape-rendering: geometricPrecision;\n  pointer-events: none;\n}\n\n.Port-module_clicker__ZivO1 {\n  opacity: 0;\n}\n\n.Port-module_clicker__ZivO1:not(.Port-module_disabled__1SC1t) {\n    cursor: crosshair;\n  }\n";
    var css = {"port":"Port-module_port__30o1q","clicker":"Port-module_clicker__ZivO1","disabled":"Port-module_disabled__1SC1t"};
    styleInject(css_248z);

    const Port = react.forwardRef(({ id, x, y, rx, ry, disabled, style, children, properties, offsetX, offsetY, className, active, onDrag = () => undefined, onDragStart = () => undefined, onDragEnd = () => undefined, onEnter = () => undefined, onLeave = () => undefined, onClick = () => undefined }, ref) => {
        const { readonly } = useCanvas();
        const [isDragging, setIsDragging] = react.useState(false);
        const [isHovered, setIsHovered] = react.useState(false);
        const newX = x - properties.width / 2;
        const newY = y - properties.height / 2;
        const onDragStartInternal = (event, initial) => {
            onDragStart(event, initial, properties);
            setIsDragging(true);
        };
        const onDragEndInternal = (event, initial) => {
            onDragEnd(event, initial, properties);
            setIsDragging(false);
        };
        const bind = useNodeDrag({
            x: newX + offsetX,
            y: newY + offsetY,
            height: properties.height,
            width: properties.width,
            disabled: disabled || readonly || (properties === null || properties === void 0 ? void 0 : properties.disabled),
            node: properties,
            onDrag,
            onDragStart: onDragStartInternal,
            onDragEnd: onDragEndInternal
        });
        if (properties.hidden) {
            return null;
        }
        const isDisabled = properties.disabled || disabled;
        const portChildProps = {
            port: properties,
            isDragging,
            isHovered,
            isDisabled,
            x,
            y,
            rx,
            ry,
            offsetX,
            offsetY
        };
        return (jsxRuntime.jsxs("g", Object.assign({ id: id }, { children: [jsxRuntime.jsx("rect", Object.assign({}, bind(), { ref: ref, height: properties.height + 14, width: properties.width + 14, x: newX - 7, y: newY - 7, className: classNames__default['default'](css.clicker, { [css.disabled]: isDisabled }), onMouseEnter: event => {
                        event.stopPropagation();
                        if (!isDisabled) {
                            setIsHovered(true);
                            onEnter(event, properties);
                        }
                    }, onMouseLeave: event => {
                        event.stopPropagation();
                        if (!isDisabled) {
                            setIsHovered(false);
                            onLeave(event, properties);
                        }
                    }, onClick: event => {
                        event.stopPropagation();
                        if (!isDisabled) {
                            onClick(event, properties);
                        }
                    } }), void 0),
                jsxRuntime.jsx(framerMotion.motion.rect, { style: style, className: classNames__default['default'](css.port, className, properties === null || properties === void 0 ? void 0 : properties.className), height: properties.height, width: properties.width, rx: rx, ry: ry, initial: {
                        scale: 0,
                        opacity: 0,
                        x: newX,
                        y: newY
                    }, animate: {
                        x: newX,
                        y: newY,
                        scale: (isDragging || active || isHovered) && !isDisabled ? 1.5 : 1,
                        opacity: 1
                    } }, `${x}-${y}`),
                children && (jsxRuntime.jsx(react.Fragment, { children: typeof children === 'function'
                        ? children(portChildProps)
                        : children }, void 0))] }), void 0));
    });

    var css_248z$1 = ".Label-module_text__126dD {\n  fill: #d6e7ff;\n  pointer-events: none;\n  font-size: 14px;\n  text-rendering: geometricPrecision;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n      -ms-user-select: none;\n          user-select: none;\n}\n";
    var css$1 = {"text":"Label-module_text__126dD"};
    styleInject(css_248z$1);

    const Label = ({ text, x, y, style, className, originalText }) => (jsxRuntime.jsxs(jsxRuntime.Fragment, { children: [jsxRuntime.jsx("title", { children: originalText }, void 0),
            jsxRuntime.jsx("g", Object.assign({ transform: `translate(${x}, ${y})` }, { children: jsxRuntime.jsx("text", Object.assign({ className: classNames__default['default'](css$1.text, className), style: style }, { children: text }), void 0) }), void 0)] }, void 0));

    var css_248z$2 = ".Remove-module_deleteX__2x11N {\n  stroke: black;\n  pointer-events: none;\n}\n\n.Remove-module_container__19Jsk {\n  will-change: transform, opacity;\n}\n\n.Remove-module_drop__2AwP8 {\n  cursor: pointer;\n  opacity: 0;\n}\n\n.Remove-module_rect__3vmn2 {\n  shape-rendering: geometricPrecision;\n  fill: #ff005d;\n  border-radius: 2px;\n  pointer-events: none;\n}\n";
    var css$2 = {"deleteX":"Remove-module_deleteX__2x11N","container":"Remove-module_container__19Jsk","drop":"Remove-module_drop__2AwP8","rect":"Remove-module_rect__3vmn2"};
    styleInject(css_248z$2);

    const Remove = ({ size = 15, className, hidden, x, y, onClick = () => undefined, onEnter = () => undefined, onLeave = () => undefined }) => {
        if (hidden) {
            return null;
        }
        const half = size / 2;
        const translateX = x - half;
        const translateY = y - half;
        return (jsxRuntime.jsxs(framerMotion.motion.g, Object.assign({ className: classNames__default['default'](className, css$2.container), initial: { scale: 0, opacity: 0, translateX, translateY }, animate: { scale: 1, opacity: 1, translateX, translateY }, whileHover: { scale: 1.2 }, whileTap: { scale: 0.8 } }, { children: [jsxRuntime.jsx("rect", { height: size * 1.5, width: size * 1.5, className: css$2.drop, onMouseEnter: onEnter, onMouseLeave: onLeave, onClick: event => {
                        event.preventDefault();
                        event.stopPropagation();
                        onClick(event);
                    } }, void 0),
                jsxRuntime.jsx("rect", { height: size, width: size, className: css$2.rect }, void 0),
                jsxRuntime.jsx("line", { x1: "2", y1: size - 2, x2: size - 2, y2: "2", className: css$2.deleteX, strokeWidth: "1" }, void 0),
                jsxRuntime.jsx("line", { x1: "2", y1: "2", x2: size - 2, y2: size - 2, className: css$2.deleteX, strokeWidth: "1" }, void 0)] }), void 0));
    };

    /**
     * Center helper.
     * Ref: https://github.com/wbkd/react-flow/blob/main/src/components/Edges/utils.ts#L18
     */
    function getBezierCenter({ sourceX, sourceY, targetX, targetY }) {
        const xOffset = Math.abs(targetX - sourceX) / 2;
        const centerX = targetX < sourceX ? targetX + xOffset : targetX - xOffset;
        const yOffset = Math.abs(targetY - sourceY) / 2;
        const centerY = targetY < sourceY ? targetY + yOffset : targetY - yOffset;
        return [centerX, centerY, xOffset, yOffset];
    }
    /**
     * Path helper utils.
     * Ref: https://github.com/wbkd/react-flow/blob/main/src/components/Edges/BezierEdge.tsx#L19
     */
    function getBezierPath({ sourceX, sourceY, sourcePosition = 'bottom', targetX, targetY, targetPosition = 'top' }) {
        const leftAndRight = ['left', 'right'];
        const [centerX, centerY] = getBezierCenter({
            sourceX,
            sourceY,
            targetX,
            targetY
        });
        let path = `M${sourceX},${sourceY} C${sourceX},${centerY} ${targetX},${centerY} ${targetX},${targetY}`;
        if (leftAndRight.includes(sourcePosition) &&
            leftAndRight.includes(targetPosition)) {
            path = `M${sourceX},${sourceY} C${centerX},${sourceY} ${centerX},${targetY} ${targetX},${targetY}`;
        }
        else if (leftAndRight.includes(targetPosition)) {
            path = `M${sourceX},${sourceY} C${sourceX},${targetY} ${sourceX},${targetY} ${targetX},${targetY}`;
        }
        else if (leftAndRight.includes(sourcePosition)) {
            path = `M${sourceX},${sourceY} C${targetX},${sourceY} ${targetX},${sourceY} ${targetX},${targetY}`;
        }
        return path;
    }
    /**
     * Calculate actual center for a path element.
     */
    function getCenter(pathElm) {
        const pLength = pathElm.getTotalLength();
        const pieceSize = pLength / 2;
        const { x, y } = pathElm.getPointAtLength(pieceSize);
        const angle = (Math.atan2(x, y) * 180) / Math.PI;
        return { x, y, angle };
    }
    /**
     * Get the angle for the path.
     */
    function getAngle(source, target) {
        const dx = source.x - target.x;
        const dy = source.y - target.y;
        let theta = Math.atan2(-dy, -dx);
        theta *= 180 / Math.PI;
        if (theta < 0) {
            theta += 360;
        }
        return theta;
    }
    /**
     * Get the center for the path element.
     */
    function getPathCenter(pathElm, firstPoint, lastPoint) {
        if (!pathElm) {
            return null;
        }
        const angle = getAngle(firstPoint, lastPoint);
        const point = getCenter(pathElm);
        return Object.assign(Object.assign({}, point), { angle });
    }

    var css_248z$3 = ".Add-module_plus__30sKV {\n  stroke: black;\n  pointer-events: none;\n}\n\n.Add-module_container__1RcJg {\n  will-change: transform, opacity;\n}\n\n.Add-module_drop__W1fxu {\n  cursor: pointer;\n  opacity: 0;\n}\n\n.Add-module_rect__3JiVn {\n  shape-rendering: geometricPrecision;\n  fill: #46FECB;\n  border-radius: 2px;\n  pointer-events: none;\n}\n";
    var css$3 = {"plus":"Add-module_plus__30sKV","container":"Add-module_container__1RcJg","drop":"Add-module_drop__W1fxu","rect":"Add-module_rect__3JiVn"};
    styleInject(css_248z$3);

    const Add = ({ x, y, className, size = 15, hidden = true, onEnter = () => undefined, onLeave = () => undefined, onClick = () => undefined }) => {
        if (hidden) {
            return null;
        }
        const half = size / 2;
        const translateX = x - half;
        const translateY = y - half;
        return (jsxRuntime.jsxs(framerMotion.motion.g, Object.assign({ className: classNames__default['default'](className, css$3.container), initial: { scale: 0, opacity: 0, translateX, translateY }, animate: { scale: 1, opacity: 1, translateX, translateY }, whileHover: { scale: 1.2 }, whileTap: { scale: 0.8 } }, { children: [jsxRuntime.jsx("rect", { height: size * 2, width: size * 2, className: css$3.drop, onClick: event => {
                        event.preventDefault();
                        event.stopPropagation();
                        onClick(event);
                    }, onMouseEnter: onEnter, onMouseLeave: onLeave }, void 0),
                jsxRuntime.jsx("rect", { height: size, width: size, className: css$3.rect }, void 0),
                jsxRuntime.jsx("line", { x1: "2", x2: size - 2, y1: half, y2: half, className: css$3.plus, strokeWidth: "1" }, void 0),
                jsxRuntime.jsx("line", { x1: half, x2: half, y1: "2", y2: size - 2, className: css$3.plus, strokeWidth: "1" }, void 0)] }), void 0));
    };

    var css_248z$4 = ".Edge-module_edge__RbmGh.Edge-module_disabled__20Zof {\n    pointer-events: none;\n  }\n  .Edge-module_edge__RbmGh:not(.Edge-module_selectionDisabled__MVwAS):not(.Edge-module_disabled__20Zof):hover .Edge-module_path__u3LT2 {\n        stroke: #a5a9e2;\n      }\n  .Edge-module_edge__RbmGh:not(.Edge-module_selectionDisabled__MVwAS):not(.Edge-module_disabled__20Zof):hover .Edge-module_path__u3LT2.Edge-module_active__2dt5E {\n          stroke: #46fecb;\n        }\n  .Edge-module_edge__RbmGh:not(.Edge-module_selectionDisabled__MVwAS):not(.Edge-module_disabled__20Zof):hover .Edge-module_path__u3LT2.Edge-module_deleteHovered__ZG2og {\n          stroke: #ff005d;\n          stroke-dasharray: 4 2;\n        }\n  .Edge-module_edge__RbmGh:not(.Edge-module_selectionDisabled__MVwAS):not(.Edge-module_disabled__20Zof) .Edge-module_clicker__3cdd0 {\n      cursor: pointer;\n    }\n\n.Edge-module_path__u3LT2 {\n  fill: transparent;\n  stroke: #485a74;\n  pointer-events: none;\n  shape-rendering: geometricPrecision;\n  stroke-width: 1pt;\n}\n\n.Edge-module_clicker__3cdd0 {\n  fill: none;\n  stroke: transparent;\n  stroke-width: 15px;\n}\n\n.Edge-module_clicker__3cdd0:focus {\n    outline: none;\n  }\n";
    var css$4 = {"edge":"Edge-module_edge__RbmGh","disabled":"Edge-module_disabled__20Zof","selectionDisabled":"Edge-module_selectionDisabled__MVwAS","path":"Edge-module_path__u3LT2","active":"Edge-module_active__2dt5E","deleteHovered":"Edge-module_deleteHovered__ZG2og","clicker":"Edge-module_clicker__3cdd0"};
    styleInject(css_248z$4);

    const Edge = ({ sections, interpolation, properties, labels, className, containerClassName, disabled, removable = true, selectable = true, upsertable = true, style, children, add = jsxRuntime.jsx(Add, {}, void 0), remove = jsxRuntime.jsx(Remove, {}, void 0), label = jsxRuntime.jsx(Label, {}, void 0), onClick = () => undefined, onKeyDown = () => undefined, onEnter = () => undefined, onLeave = () => undefined, onRemove = () => undefined, onAdd = () => undefined }) => {
        const pathRef = react.useRef(null);
        const [deleteHovered, setDeleteHovered] = react.useState(false);
        const [center, setCenter] = react.useState(null);
        const { selections, readonly } = useCanvas();
        const isActive = (selections === null || selections === void 0 ? void 0 : selections.length) ? selections.includes(properties === null || properties === void 0 ? void 0 : properties.id)
            : false;
        const isDisabled = disabled || (properties === null || properties === void 0 ? void 0 : properties.disabled);
        const canSelect = selectable && !(properties === null || properties === void 0 ? void 0 : properties.selectionDisabled);
        // The "d" attribute defines a path to be drawn. See https://developer.mozilla.org/en-US/docs/Web/SVG/Attribute/d
        const d = react.useMemo(() => {
            if (!(sections === null || sections === void 0 ? void 0 : sections.length)) {
                return null;
            }
            // Handle bend points that elk gives
            // us separately from drag points
            if (sections[0].bendPoints) {
                const points = sections
                    ? [
                        sections[0].startPoint,
                        ...(sections[0].bendPoints || []),
                        sections[0].endPoint
                    ]
                    : [];
                let pathFn = d3Shape.line()
                    .x((d) => d.x)
                    .y((d) => d.y);
                if (interpolation !== 'linear') {
                    pathFn =
                        interpolation === 'curved'
                            ? pathFn.curve(d3Shape.curveBundle.beta(1))
                            : interpolation;
                }
                return pathFn(points);
            }
            else {
                return getBezierPath({
                    sourceX: sections[0].startPoint.x,
                    sourceY: sections[0].startPoint.y,
                    targetX: sections[0].endPoint.x,
                    targetY: sections[0].endPoint.y
                });
            }
        }, [sections]);
        react.useEffect(() => {
            if ((sections === null || sections === void 0 ? void 0 : sections.length) > 0) {
                setCenter(getPathCenter(pathRef.current, sections[0].startPoint, sections[0].endPoint));
            }
        }, [sections]);
        const edgeChildProps = {
            edge: properties,
            center,
            pathRef
        };
        return (jsxRuntime.jsxs("g", Object.assign({ className: classNames__default['default'](css$4.edge, containerClassName, {
                [css$4.disabled]: isDisabled,
                [css$4.selectionDisabled]: !canSelect
            }) }, { children: [jsxRuntime.jsx("path", { ref: pathRef, style: style, className: classNames__default['default'](css$4.path, properties === null || properties === void 0 ? void 0 : properties.className, className, {
                        [css$4.active]: isActive,
                        [css$4.deleteHovered]: deleteHovered
                    }), d: d, markerEnd: "url(#end-arrow)" }, void 0),
                jsxRuntime.jsx("path", { className: css$4.clicker, d: d, tabIndex: -1, onClick: event => {
                        event.preventDefault();
                        event.stopPropagation();
                        if (!isDisabled && canSelect) {
                            onClick(event, properties);
                        }
                    }, onKeyDown: event => {
                        event.preventDefault();
                        event.stopPropagation();
                        if (!isDisabled) {
                            onKeyDown(event, properties);
                        }
                    }, onMouseEnter: event => {
                        event.stopPropagation();
                        if (!isDisabled) {
                            onEnter(event, properties);
                        }
                    }, onMouseLeave: event => {
                        event.stopPropagation();
                        if (!isDisabled) {
                            onLeave(event, properties);
                        }
                    } }, void 0),
                children && (jsxRuntime.jsx(react.Fragment, { children: typeof children === 'function'
                        ? children(edgeChildProps)
                        : children }, void 0)),
                (labels === null || labels === void 0 ? void 0 : labels.length) > 0 &&
                    labels.map((l, index) => (jsxRuntime.jsx(rdk.CloneElement, Object.assign({ element: label, edgeChildProps: edgeChildProps }, l), index))),
                !isDisabled && center && !readonly && remove && removable && (jsxRuntime.jsx(rdk.CloneElement, Object.assign({ element: remove }, center, { hidden: remove.props.hidden !== undefined ? remove.props.hidden : !isActive, onClick: (event) => {
                        event.preventDefault();
                        event.stopPropagation();
                        onRemove(event, properties);
                        setDeleteHovered(false);
                    }, onEnter: () => setDeleteHovered(true), onLeave: () => setDeleteHovered(false) }), void 0)),
                !isDisabled && center && !readonly && add && upsertable && (jsxRuntime.jsx(rdk.CloneElement, Object.assign({ element: add }, center, { onClick: event => {
                        event.preventDefault();
                        event.stopPropagation();
                        onAdd(event, properties);
                    } }), void 0))] }), void 0));
    };
    Edge.defaultProps = {
        interpolation: 'curved'
    };

    var css_248z$5 = ".Node-module_rect__1Eal3 {\n  fill: #2b2c3e;\n  transition: stroke 100ms ease-in-out;\n  stroke: #475872;\n  shape-rendering: geometricPrecision;\n  stroke-width: 1pt;\n}\n\n  .Node-module_rect__1Eal3:not(.Node-module_selectionDisabled__2zufG):not(.Node-module_disabled__bZzf8) {\n    cursor: pointer;\n  }\n\n  .Node-module_rect__1Eal3:not(.Node-module_selectionDisabled__2zufG):not(.Node-module_disabled__bZzf8):hover {\n      stroke: #a5a9e2;\n    }\n\n  .Node-module_rect__1Eal3:not(.Node-module_selectionDisabled__2zufG):not(.Node-module_disabled__bZzf8).Node-module_dragging__24Avg {\n      stroke: #a5a9e2;\n    }\n\n  .Node-module_rect__1Eal3:not(.Node-module_selectionDisabled__2zufG):not(.Node-module_disabled__bZzf8).Node-module_active__1b2HC {\n      stroke: #46fecb;\n    }\n\n  .Node-module_rect__1Eal3:not(.Node-module_selectionDisabled__2zufG):not(.Node-module_disabled__bZzf8).Node-module_unlinkable__p6w5x {\n      stroke: #ff005d;\n    }\n\n  .Node-module_rect__1Eal3:not(.Node-module_selectionDisabled__2zufG):not(.Node-module_disabled__bZzf8).Node-module_deleteHovered__36-dV {\n      stroke: #ff005d !important;\n      stroke-dasharray: 4 2;\n    }\n\n  .Node-module_rect__1Eal3:focus {\n    outline: none;\n  }\n\n  .Node-module_rect__1Eal3.Node-module_children__1kq65 {\n    fill: transparent;\n    stroke: #475872;\n  }\n";
    var css$5 = {"rect":"Node-module_rect__1Eal3","selectionDisabled":"Node-module_selectionDisabled__2zufG","disabled":"Node-module_disabled__bZzf8","dragging":"Node-module_dragging__24Avg","active":"Node-module_active__1b2HC","unlinkable":"Node-module_unlinkable__p6w5x","deleteHovered":"Node-module_deleteHovered__36-dV","children":"Node-module_children__1kq65"};
    styleInject(css_248z$5);

    const Node = ({ id, x, y, ports, labels, height, width, properties, animated, className, rx = 2, ry = 2, offsetX = 0, offsetY = 0, icon, disabled, style, children, nodes, edges, draggable = true, linkable = true, selectable = true, removable = true, dragType = 'multiportOnly', dragCursor = 'crosshair', childEdge = jsxRuntime.jsx(Edge, {}, void 0), childNode = jsxRuntime.jsx(Node, {}, void 0), remove = jsxRuntime.jsx(Remove, {}, void 0), port = jsxRuntime.jsx(Port, {}, void 0), label = jsxRuntime.jsx(Label, {}, void 0), onRemove, onDrag, onDragStart, onDragEnd, onClick, onKeyDown, onEnter, onLeave }) => {
        const nodeRef = react.useRef(null);
        const controls = framerMotion.useAnimation();
        const _a = useCanvas(), { canLinkNode, enteredNode, selections, readonly } = _a, canvas = __rest(_a, ["canLinkNode", "enteredNode", "selections", "readonly"]);
        const [deleteHovered, setDeleteHovered] = react.useState(false);
        const [dragging, setDragging] = react.useState(false);
        const [isLinkable, setIsLinkable] = react.useState(true);
        const isActive = (selections === null || selections === void 0 ? void 0 : selections.length) ? selections.includes(properties.id)
            : null;
        const isNodeDrag = id.includes('node-drag');
        const newX = x + offsetX;
        const newY = y + offsetY;
        const isMultiPort = dragType === 'multiportOnly' &&
            (ports === null || ports === void 0 ? void 0 : ports.filter(p => { var _a; return !((_a = p.properties) === null || _a === void 0 ? void 0 : _a.hidden); }).length) > 1;
        const isDisabled = disabled || (properties === null || properties === void 0 ? void 0 : properties.disabled);
        const canDrag = ['port', 'multiportOnly'].includes(dragType)
            ? linkable
            : draggable;
        const canSelect = selectable && !(properties === null || properties === void 0 ? void 0 : properties.selectionDisabled);
        const getDragType = react.useCallback((hasPort) => {
            let activeDragType = null;
            if (!hasPort) {
                if (dragType === 'all' || dragType === 'node') {
                    activeDragType = 'node';
                }
                else if (!isMultiPort) {
                    activeDragType = 'port';
                }
            }
            else {
                if (dragType === 'all' || dragType === 'port' || isMultiPort) {
                    activeDragType = 'port';
                }
            }
            return activeDragType;
        }, [dragType, isMultiPort]);
        const setDragCursor = react.useCallback((dragType) => {
            if (dragType) {
                document.body.classList.add('dragging');
                document.body.style.cursor = dragType === 'node' ? 'grab' : 'crosshair';
            }
            else {
                document.body.classList.remove('dragging');
                document.body.style.cursor = 'auto';
            }
        }, []);
        const bind = useNodeDrag({
            x: newX,
            y: newY,
            height,
            width,
            disabled: isDisabled || isMultiPort || readonly || !canDrag || dragType === 'port',
            node: properties,
            onDrag: (...props) => {
                if (!isDisabled && canDrag) {
                    canvas.onDrag(...props);
                    onDrag === null || onDrag === void 0 ? void 0 : onDrag(...props);
                }
            },
            onDragStart: (event, coords, node, port) => {
                if (!isDisabled && canDrag) {
                    // @ts-ignore
                    event.dragType = getDragType(false);
                    // @ts-ignore
                    setDragCursor(event.dragType);
                    canvas.onDragStart(event, coords, node, port);
                    onDragStart === null || onDragStart === void 0 ? void 0 : onDragStart(event, coords, node, port);
                    setDragging(true);
                }
            },
            onDragEnd: (event, coords, node, port) => {
                if (!isDisabled && canDrag) {
                    // @ts-ignore
                    event.dragType = getDragType(false);
                    // @ts-ignore
                    event.srcElement = nodeRef.current;
                    canvas.onDragEnd(event, coords, node, port);
                    onDragEnd === null || onDragEnd === void 0 ? void 0 : onDragEnd(event, coords, node, port);
                    setDragging(false);
                    setDragCursor(null);
                }
            }
        });
        react.useEffect(() => {
            if ((enteredNode === null || enteredNode === void 0 ? void 0 : enteredNode.id) === properties.id) {
                setIsLinkable(checkNodeLinkable(properties, enteredNode, canLinkNode));
            }
            return () => setIsLinkable(true);
        }, [canLinkNode, enteredNode, properties]);
        react.useEffect(() => {
            controls.set({
                opacity: 1,
                translateX: x,
                translateY: y
            });
        }, [controls, x, y]);
        const nodeChildProps = {
            height,
            width,
            x,
            y,
            node: properties,
            nodes,
            edges
        };
        const onClickCallback = react.useCallback(event => {
            event.preventDefault();
            event.stopPropagation();
            if (!isDisabled && canSelect) {
                onClick === null || onClick === void 0 ? void 0 : onClick(event, properties);
            }
        }, [canSelect, isDisabled, onClick, properties]);
        const onKeyDownCallback = react.useCallback(event => {
            event.preventDefault();
            if (!isDisabled) {
                onKeyDown === null || onKeyDown === void 0 ? void 0 : onKeyDown(event, properties);
            }
        }, [isDisabled, onKeyDown, properties]);
        const onTouchStartCallback = react.useCallback(event => {
            event.preventDefault();
            event.stopPropagation();
        }, []);
        const onMouseEnterCallback = react.useCallback(event => {
            event.stopPropagation();
            canvas.onEnter(event, properties);
            if (!isDisabled) {
                onEnter === null || onEnter === void 0 ? void 0 : onEnter(event, properties);
            }
        }, [canvas, isDisabled, onEnter, properties]);
        const onMouseLeaveCallback = react.useCallback(event => {
            event.stopPropagation();
            canvas.onLeave(event, properties);
            if (!isDisabled) {
                onLeave === null || onLeave === void 0 ? void 0 : onLeave(event, properties);
            }
        }, [canvas, isDisabled, onLeave, properties]);
        const onDragStartCallback = react.useCallback((event, initial, data) => {
            if (!isDisabled && linkable) {
                // @ts-ignore
                event.dragType = getDragType(true);
                // @ts-ignore
                setDragCursor(event.dragType);
                canvas.onDragStart(event, initial, properties, data);
                onDragStart === null || onDragStart === void 0 ? void 0 : onDragStart(event, initial, properties, data);
                setDragging(true);
            }
        }, [
            canvas,
            getDragType,
            isDisabled,
            linkable,
            onDragStart,
            properties,
            setDragCursor
        ]);
        const onDragCallback = react.useCallback((event, initial, data) => {
            if (!isDisabled && linkable) {
                canvas.onDrag(event, initial, properties, data);
                onDrag === null || onDrag === void 0 ? void 0 : onDrag(event, initial, properties, data);
            }
        }, [canvas, isDisabled, linkable, onDrag, properties]);
        const onDragEndCallback = react.useCallback((event, initial, data) => {
            if (!isDisabled && linkable) {
                // @ts-ignore
                event.dragType = getDragType(true);
                setDragCursor(null);
                canvas.onDragEnd(event, initial, properties, data);
                onDragEnd === null || onDragEnd === void 0 ? void 0 : onDragEnd(event, initial, properties, data);
                setDragging(false);
            }
        }, [
            canvas,
            getDragType,
            isDisabled,
            linkable,
            onDragEnd,
            properties,
            setDragCursor
        ]);
        return (jsxRuntime.jsxs(framerMotion.motion.g, Object.assign({ id: id, initial: {
                cursor: 'initial',
                opacity: 0,
                translateX: x,
                translateY: y
            }, animate: controls }, { children: [jsxRuntime.jsx(framerMotion.motion.rect, Object.assign({}, bind(), { ref: nodeRef, tabIndex: -1, onKeyDown: onKeyDownCallback, onClick: onClickCallback, onTouchStart: onTouchStartCallback, onMouseEnter: onMouseEnterCallback, onMouseLeave: onMouseLeaveCallback, className: classNames__default['default'](css$5.rect, className, properties === null || properties === void 0 ? void 0 : properties.className, {
                        [css$5.active]: isActive,
                        [css$5.disabled]: isDisabled,
                        [css$5.unlinkable]: isLinkable === false && !isNodeDrag,
                        [css$5.dragging]: dragging,
                        [css$5.children]: (nodes === null || nodes === void 0 ? void 0 : nodes.length) > 0,
                        [css$5.deleteHovered]: deleteHovered,
                        [css$5.selectionDisabled]: !canSelect
                    }), style: style, height: height, width: width, rx: rx, ry: ry, initial: {
                        opacity: 0
                    }, animate: {
                        opacity: 1,
                        transition: !animated ? { type: false, duration: 0 } : {}
                    } }), void 0),
                children && (jsxRuntime.jsx(react.Fragment, { children: typeof children === 'function'
                        ? children(nodeChildProps)
                        : children }, void 0)),
                icon && properties.icon && (jsxRuntime.jsx(rdk.CloneElement, Object.assign({ element: icon }, properties.icon), void 0)),
                label &&
                    (labels === null || labels === void 0 ? void 0 : labels.length) > 0 &&
                    labels.map((l, index) => (jsxRuntime.jsx(rdk.CloneElement, Object.assign({ element: label }, l), index))),
                port &&
                    (ports === null || ports === void 0 ? void 0 : ports.length) > 0 &&
                    ports.map(p => (jsxRuntime.jsx(rdk.CloneElement, Object.assign({ element: port, active: !isMultiPort && dragging, disabled: isDisabled || !linkable, offsetX: newX, offsetY: newY, onDragStart: onDragStartCallback, onDrag: onDragCallback, onDragEnd: onDragEndCallback }, p, { id: `${id}-port-${p.id}` }), p.id))),
                !isDisabled && isActive && !readonly && remove && removable && (jsxRuntime.jsx(rdk.CloneElement, { element: remove, y: height / 2, x: width, onClick: (event) => {
                        event.preventDefault();
                        event.stopPropagation();
                        onRemove === null || onRemove === void 0 ? void 0 : onRemove(event, properties);
                        setDeleteHovered(false);
                    }, onEnter: () => setDeleteHovered(true), onLeave: () => setDeleteHovered(false) }, void 0)),
                jsxRuntime.jsxs("g", { children: [(edges === null || edges === void 0 ? void 0 : edges.length) > 0 &&
                            edges.map((e) => {
                                const element = typeof childEdge === 'function' ? childEdge(e) : childEdge;
                                return (jsxRuntime.jsx(rdk.CloneElement, Object.assign({ element: element, id: `${id}-edge-${e.id}`, disabled: isDisabled }, e, { properties: Object.assign(Object.assign({}, e.properties), (e.data ? { data: e.data } : {})) }), e.id));
                            }),
                        (nodes === null || nodes === void 0 ? void 0 : nodes.length) > 0 &&
                            nodes.map((_a) => {
                                var _b, _c, _d, _e, _f, _g;
                                var { children } = _a, n = __rest(_a, ["children"]);
                                const element = typeof childNode === 'function' ? childNode(n) : childNode;
                                const elementDisabled = ((_b = element.props) === null || _b === void 0 ? void 0 : _b.disabled) != null
                                    ? element.props.disabled
                                    : disabled;
                                const elementAnimated = ((_c = element.props) === null || _c === void 0 ? void 0 : _c.animated) != null
                                    ? element.props.animated
                                    : animated;
                                const elementDraggable = ((_d = element.props) === null || _d === void 0 ? void 0 : _d.draggable) != null
                                    ? element.props.draggable
                                    : draggable;
                                const elementLinkable = ((_e = element.props) === null || _e === void 0 ? void 0 : _e.linkable) != null
                                    ? element.props.linkable
                                    : linkable;
                                const elementSelectable = ((_f = element.props) === null || _f === void 0 ? void 0 : _f.selectable) != null
                                    ? element.props.selectable
                                    : selectable;
                                const elementRemovable = ((_g = element.props) === null || _g === void 0 ? void 0 : _g.removable) != null
                                    ? element.props.removable
                                    : removable;
                                return (jsxRuntime.jsx(rdk.CloneElement, Object.assign({ element: element, id: `${id}-node-${n.id}`, disabled: elementDisabled, nodes: children, offsetX: newX, offsetY: newY, animated: elementAnimated, children: element.props.children, childNode: childNode, dragCursor: dragCursor, dragType: dragType, childEdge: childEdge, draggable: elementDraggable, linkable: elementLinkable, selectable: elementSelectable, removable: elementRemovable, onDragStart: onDragStart, onDrag: onDrag, onDragEnd: onDragEnd, onClick: onClick, onEnter: onEnter, onLeave: onLeave, onKeyDown: onKeyDown, onRemove: onRemove }, n), n.id));
                            })] }, void 0)] }), void 0));
    };

    var css_248z$6 = ".Arrow-module_arrow__aEgOT {\n  pointer-events: none;\n  shape-rendering: geometricPrecision;\n  fill: #485a74;\n}\n";
    var css$6 = {"arrow":"Arrow-module_arrow__aEgOT"};
    styleInject(css_248z$6);

    const Arrow = ({ size = 8, y = 0, x = 0, angle = 0, className, style }) => (jsxRuntime.jsx("path", { style: style, transform: `translate(${x}, ${y}) rotate(${angle})`, className: classNames__default['default'](css$6.arrow, className), d: `M0,-${size / 2}L${size},0L0,${size / 2}` }, void 0));

    const MarkerArrow = ({ size = 8, className, style }) => (jsxRuntime.jsx("marker", Object.assign({ id: "end-arrow", viewBox: `0 -${size / 2} ${size} ${size}`, refX: `${size}`, markerWidth: `${size}`, markerHeight: `${size}`, orient: "auto" }, { children: jsxRuntime.jsx(Arrow, { size: size, style: style, className: className }, void 0) }), "end-arrow"));

    var css_248z$7 = ".Canvas-module_container__22cN4.Canvas-module_pannable__1d7xd {\n    overflow: auto;\n  }\n  .Canvas-module_container__22cN4:focus {\n    outline: none;\n  }\n\n.dragging {\n  -webkit-touch-callout: none;\n  -webkit-user-select: none;\n  -moz-user-select: none;\n  -ms-user-select: none;\n  user-select: none;\n}\n\n.Canvas-module_dragNode__2q6bP {\n  pointer-events: none;\n}\n";
    var css$7 = {"container":"Canvas-module_container__22cN4","pannable":"Canvas-module_pannable__1d7xd","dragNode":"Canvas-module_dragNode__2q6bP"};
    styleInject(css_248z$7);

    const InternalCanvas = react.forwardRef(({ className, height = '100%', width = '100%', readonly, disabled = false, animated = true, arrow = jsxRuntime.jsx(MarkerArrow, {}, void 0), node = jsxRuntime.jsx(Node, {}, void 0), edge = jsxRuntime.jsx(Edge, {}, void 0), dragNode = jsxRuntime.jsx(Node, {}, void 0), dragEdge = jsxRuntime.jsx(Edge, { add: null }, void 0), onMouseEnter = () => undefined, onMouseLeave = () => undefined, onCanvasClick = () => undefined }, ref) => {
        var _a, _b, _c, _d, _e;
        const id = rdk.useId();
        const _f = useCanvas(), { pannable, dragCoords, dragNode: canvasDragNode, layout, containerRef, svgRef, canvasHeight, canvasWidth, xy, zoom, setZoom, observe, zoomIn, zoomOut, positionCanvas, fitCanvas, setScrollXY } = _f, rest = __rest(_f, ["pannable", "dragCoords", "dragNode", "layout", "containerRef", "svgRef", "canvasHeight", "canvasWidth", "xy", "zoom", "setZoom", "observe", "zoomIn", "zoomOut", "positionCanvas", "fitCanvas", "setScrollXY"]);
        const [dragType, setDragType] = react.useState(null);
        react.useImperativeHandle(ref, () => (Object.assign(Object.assign({}, rest), { observe,
            zoom,
            xy,
            layout,
            canvasHeight,
            containerRef,
            canvasWidth,
            svgRef,
            positionCanvas,
            setZoom,
            zoomIn,
            zoomOut,
            fitCanvas,
            setScrollXY })));
        const mount = react.useRef(false);
        const dragNodeData = react.useMemo(() => getDragNodeData(canvasDragNode, layout === null || layout === void 0 ? void 0 : layout.children), [canvasDragNode, layout === null || layout === void 0 ? void 0 : layout.children]);
        const [dragNodeDataWithChildren, setDragNodeDataWithChildren] = react.useState(dragNodeData);
        const dragNodeElement = react.useMemo(() => typeof dragNode === 'function'
            ? dragNode(dragNodeData)
            : dragNode, [dragNode, dragNodeData]);
        react.useLayoutEffect(() => {
            if (!mount.current && layout !== null && xy[0] > 0 && xy[1] > 0) {
                mount.current = true;
            }
        }, [layout, xy]);
        const onDragStart = react.useCallback(event => {
            setDragType(event.dragType);
        }, []);
        const createDragNodeChildren = react.useCallback((children) => {
            if (!children || !Array.isArray(children)) {
                return [];
            }
            return children.map((_a) => {
                var { children } = _a, n = __rest(_a, ["children"]);
                const element = typeof dragNode === 'function'
                    ? dragNode(n)
                    : dragNode;
                return (jsxRuntime.jsx(rdk.CloneElement, Object.assign({ element: element, disabled: true, children: element.props.children, animated: animated, nodes: children, childEdge: dragEdge, childNode: dragNode }, n, { onDragStart: onDragStart, id: `${id}-node-${n.id}-node-drag` }), `${id}-node-${n.id}-node-drag`));
            });
        }, 
        // Passing in dragEdge (JSX) will cause the function to be recalculated constantly,
        // triggering the below useEffect. Since dragEdge and dragNode are passed in props
        // on Canvas, they are unlikely to change and can be ignored
        // eslint-disable-next-line react-hooks/exhaustive-deps
        [animated, id]);
        react.useEffect(() => {
            if (dragNodeData && Object.keys(dragNodeData).length > 0) {
                const nodeCopy = Object.assign({}, dragNodeData);
                // Node children is expecting a list of React Elements, need to create a list of elements
                nodeCopy.children = createDragNodeChildren(nodeCopy.children);
                setDragNodeDataWithChildren(nodeCopy);
            }
        }, [createDragNodeChildren, dragNodeData, layout === null || layout === void 0 ? void 0 : layout.children]);
        return (jsxRuntime.jsx("div", Object.assign({ style: { height, width }, className: classNames__default['default'](css$7.container, className, {
                [css$7.pannable]: pannable
            }), ref: el => {
                // Really not a fan of this API change...
                // https://github.com/wellyshen/react-cool-dimensions#how-to-share-a-ref
                observe(el);
                // @ts-ignore
                containerRef.current = el;
            }, onMouseEnter: onMouseEnter, onMouseLeave: onMouseLeave }, { children: jsxRuntime.jsxs("svg", Object.assign({ xmlns: "http://www.w3.org/2000/svg", id: id, ref: svgRef, height: canvasHeight, width: canvasWidth, onClick: onCanvasClick }, { children: [arrow !== null && (jsxRuntime.jsx("defs", { children: jsxRuntime.jsx(rdk.CloneElement, Object.assign({ element: arrow }, arrow), void 0) }, void 0)),
                    jsxRuntime.jsxs(framerMotion.motion.g, Object.assign({ initial: {
                            opacity: 0,
                            scale: 0,
                            transition: {
                                translateX: false,
                                translateY: false
                            }
                        }, animate: {
                            opacity: 1,
                            translateX: xy[0],
                            translateY: xy[1],
                            scale: zoom,
                            transition: animated
                                ? {
                                    velocity: 100,
                                    translateX: { duration: mount.current ? 0.3 : 0 },
                                    translateY: { duration: mount.current ? 0.3 : 0 },
                                    opacity: { duration: 0.8 },
                                    when: 'beforeChildren'
                                }
                                : {
                                    type: false,
                                    duration: 0,
                                    when: 'beforeChildren'
                                }
                        } }, { children: [(_a = layout === null || layout === void 0 ? void 0 : layout.children) === null || _a === void 0 ? void 0 : _a.map((_a) => {
                                var { children } = _a, n = __rest(_a, ["children"]);
                                const element = typeof node === 'function' ? node(n) : node;
                                return (jsxRuntime.jsx(rdk.CloneElement, Object.assign({ element: element, disabled: disabled, children: element.props.children, animated: animated, nodes: children, childEdge: edge, childNode: node }, n, { onDragStart: onDragStart, id: `${id}-node-${n.id}` }), n.id));
                            }), (_b = layout === null || layout === void 0 ? void 0 : layout.edges) === null || _b === void 0 ? void 0 : _b.map(e => {
                                const element = typeof edge === 'function' ? edge(e) : edge;
                                return (jsxRuntime.jsx(rdk.CloneElement, Object.assign({ element: element, disabled: disabled, children: element.props.children }, e, { properties: Object.assign(Object.assign({}, e.properties), (e.data ? { data: e.data } : {})), id: `${id}-edge-${e.id}` }), e.id));
                            }), dragCoords !== null &&
                                dragEdge &&
                                dragType === 'port' &&
                                !readonly && (jsxRuntime.jsx(rdk.CloneElement, { element: dragEdge, id: `${id}-edge-drag`, disabled: true, sections: dragCoords }, void 0)), (_c = layout === null || layout === void 0 ? void 0 : layout.children) === null || _c === void 0 ? void 0 : _c.map((_a) => {
                                var { children, ports } = _a, n = __rest(_a, ["children", "ports"]);
                                return (jsxRuntime.jsx(react.Fragment, { children: (ports === null || ports === void 0 ? void 0 : ports.length) > 0 && (jsxRuntime.jsx(framerMotion.motion.g, Object.assign({ animate: {
                                            translateX: n.x,
                                            translateY: n.y,
                                            transition: { duration: 0 }
                                        } }, { children: ports.map((port, index) => (jsxRuntime.jsx("use", { xlinkHref: `#${id}-node-${n.id}-port-${port.id}`, style: { pointerEvents: 'none' } }, index))) }), n.id)) }, n.id));
                            }), dragCoords !== null &&
                                dragNodeDataWithChildren &&
                                dragType === 'node' &&
                                !readonly && (jsxRuntime.jsx(rdk.CloneElement, Object.assign({}, dragNodeDataWithChildren, { element: dragNodeElement, height: ((_d = dragNodeDataWithChildren === null || dragNodeDataWithChildren === void 0 ? void 0 : dragNodeDataWithChildren.props) === null || _d === void 0 ? void 0 : _d.height) || (dragNodeDataWithChildren === null || dragNodeDataWithChildren === void 0 ? void 0 : dragNodeDataWithChildren.height), width: ((_e = dragNodeDataWithChildren === null || dragNodeDataWithChildren === void 0 ? void 0 : dragNodeDataWithChildren.props) === null || _e === void 0 ? void 0 : _e.width) || (dragNodeDataWithChildren === null || dragNodeDataWithChildren === void 0 ? void 0 : dragNodeDataWithChildren.width), id: `${id}-node-drag`, animated: animated, className: css$7.dragNode, disabled: true, x: dragCoords[0].endPoint.x, y: dragCoords[0].endPoint.y }), void 0))] }), void 0)] }), void 0) }), void 0));
    });
    const Canvas = react.forwardRef((_a, ref) => {
        var { selections = [], readonly = false, fit = false, nodes = [], edges = [], maxHeight = 2000, maxWidth = 2000, direction = 'DOWN', pannable = true, zoom = 1, defaultPosition = exports.CanvasPosition.CENTER, zoomable = true, minZoom = -0.5, maxZoom = 1, onNodeLink = () => undefined, onNodeLinkCheck = () => undefined, onLayoutChange = () => undefined, onZoomChange = () => undefined, layoutOptions } = _a, rest = __rest(_a, ["selections", "readonly", "fit", "nodes", "edges", "maxHeight", "maxWidth", "direction", "pannable", "zoom", "defaultPosition", "zoomable", "minZoom", "maxZoom", "onNodeLink", "onNodeLinkCheck", "onLayoutChange", "onZoomChange", "layoutOptions"]);
        return (jsxRuntime.jsx(CanvasProvider, Object.assign({ layoutOptions: layoutOptions, nodes: nodes, edges: edges, zoom: zoom, defaultPosition: defaultPosition, minZoom: minZoom, maxZoom: maxZoom, fit: fit, maxHeight: maxHeight, maxWidth: maxWidth, direction: direction, pannable: pannable, zoomable: zoomable, readonly: readonly, onLayoutChange: onLayoutChange, selections: selections, onZoomChange: onZoomChange, onNodeLink: onNodeLink, onNodeLinkCheck: onNodeLinkCheck }, { children: jsxRuntime.jsx(InternalCanvas, Object.assign({ ref: ref }, rest), void 0) }), void 0));
    });

    var css_248z$8 = ".Icon-module_icon__36fxL {\n  pointer-events: none;\n}\n";
    var css$8 = {"icon":"Icon-module_icon__36fxL"};
    styleInject(css_248z$8);

    const Icon = ({ x, y, url, style, className, height = 40, width = 40 }) => (jsxRuntime.jsx("g", Object.assign({ className: classNames__default['default'](css$8.icon, className), transform: `translate(${x - width / 2}, ${y - height / 2})` }, { children: jsxRuntime.jsx("image", { style: style, xlinkHref: url, width: width, height: height }, void 0) }), void 0));

    /**
     * Helper function for upserting a node in a edge.
     */
    function upsertNode(nodes, edges, edge, newNode) {
        const oldEdgeIndex = edges.findIndex(e => e.id === edge.id);
        const edgeBeforeNewNode = Object.assign(Object.assign({}, edge), { id: `${edge.from}-${newNode.id}`, to: newNode.id });
        const edgeAfterNewNode = Object.assign(Object.assign({}, edge), { id: `${newNode.id}-${edge.to}`, from: newNode.id });
        if (edge.fromPort && edge.toPort) {
            edgeBeforeNewNode.fromPort = edge.fromPort;
            edgeBeforeNewNode.toPort = `${newNode.id}-to`;
            edgeAfterNewNode.fromPort = `${newNode.id}-from`;
            edgeAfterNewNode.toPort = edge.toPort;
        }
        edges.splice(oldEdgeIndex, 1, edgeBeforeNewNode, edgeAfterNewNode);
        return {
            nodes: [...nodes, newNode],
            edges: [...edges]
        };
    }
    /**
     * Helper function for removing a node between edges and
     * linking the children.
     */
    function removeAndUpsertNodes(nodes, edges, removeNodes, onNodeLinkCheck) {
        if (!Array.isArray(removeNodes)) {
            removeNodes = [removeNodes];
        }
        const nodeIds = removeNodes.map((n) => n.id);
        const newNodes = nodes.filter((n) => !nodeIds.includes(n.id));
        const newEdges = edges.filter((e) => !nodeIds.includes(e.from) && !nodeIds.includes(e.to));
        for (const nodeId of nodeIds) {
            const sourceEdges = edges.filter((e) => e.to === nodeId);
            const targetEdges = edges.filter((e) => e.from === nodeId);
            for (const sourceEdge of sourceEdges) {
                for (const targetEdge of targetEdges) {
                    const sourceNode = nodes.find((n) => n.id === sourceEdge.from);
                    const targetNode = nodes.find((n) => n.id === targetEdge.to);
                    if (sourceNode && targetNode) {
                        const canLink = onNodeLinkCheck === null || onNodeLinkCheck === void 0 ? void 0 : onNodeLinkCheck(newNodes, newEdges, sourceNode, targetNode);
                        if (canLink === undefined || canLink) {
                            newEdges.push({
                                id: `${sourceNode.id}-${targetNode.id}`,
                                from: sourceNode.id,
                                to: targetNode.id,
                                parent: sourceNode === null || sourceNode === void 0 ? void 0 : sourceNode.parent
                            });
                        }
                    }
                }
            }
        }
        return {
            edges: newEdges,
            nodes: newNodes
        };
    }
    /**
     * Helper function to remove a node and its related edges.
     */
    function removeNode(nodes, edges, removeNodes) {
        if (!Array.isArray(removeNodes)) {
            removeNodes = [removeNodes];
        }
        const newNodes = [];
        const newEdges = [];
        for (const node of nodes) {
            const has = removeNodes.some((n) => n === node.id);
            if (!has) {
                newNodes.push(node);
            }
        }
        for (const edge of edges) {
            const has = removeNodes.some((n) => n === edge.from || n === edge.to);
            if (!has) {
                newEdges.push(edge);
            }
        }
        return {
            nodes: newNodes,
            edges: newEdges
        };
    }
    /**
     * Helper function to remove a node's related edges.
     */
    function removeEdgesFromNode(nodeId, edges) {
        return edges.filter(edge => !(edge.to === nodeId || edge.from === nodeId));
    }
    /**
     * Remove edge(s)
     */
    function removeEdge(edges, edge) {
        const deletions = !Array.isArray(edge) ? [edge] : edge;
        const edgeIds = deletions.map((e) => e.id);
        return edges.filter((e) => !edgeIds.includes(e.id));
    }
    /**
     * Create an edge given 2 nodes.
     */
    function createEdgeFromNodes(fromNode, toNode) {
        return {
            id: `${fromNode.id}-${toNode.id}`,
            from: fromNode.id,
            to: toNode.id,
            parent: toNode.parent
        };
    }
    /**
     * Add a node and optional edge.
     */
    function addNodeAndEdge(nodes, edges, node, toNode) {
        return {
            nodes: [...nodes, node],
            edges: [
                ...edges,
                ...(toNode
                    ? [createEdgeFromNodes(toNode, node)]
                    : [])
            ]
        };
    }

    const useSelection = ({ selections = [], nodes = [], edges = [], hotkeys = ['selectAll', 'deselect', 'delete'], disabled, onSelection, onDataChange }) => {
        const [internalSelections, setInternalSelections] = react.useState(selections);
        const [metaKeyDown, setMetaKeyDown] = react.useState(false);
        const addSelection = (item) => {
            if (!disabled) {
                const has = internalSelections.includes(item);
                if (!has) {
                    const next = [...internalSelections, item];
                    onSelection === null || onSelection === void 0 ? void 0 : onSelection(next);
                    setInternalSelections(next);
                }
            }
        };
        const removeSelection = (item) => {
            if (!disabled) {
                const has = internalSelections.includes(item);
                if (has) {
                    const next = internalSelections.filter(i => i !== item);
                    onSelection === null || onSelection === void 0 ? void 0 : onSelection(next);
                    setInternalSelections(next);
                }
            }
        };
        const toggleSelection = (item) => {
            const has = internalSelections.includes(item);
            if (has) {
                removeSelection(item);
            }
            else {
                addSelection(item);
            }
        };
        const clearSelections = (next = []) => {
            if (!disabled) {
                setInternalSelections(next);
                onSelection === null || onSelection === void 0 ? void 0 : onSelection(next);
            }
        };
        const onClick = (event, data) => {
            event.preventDefault();
            event.stopPropagation();
            if (!metaKeyDown) {
                clearSelections([data.id]);
            }
            else {
                toggleSelection(data.id);
            }
            setMetaKeyDown(false);
        };
        const onKeyDown = event => {
            event.preventDefault();
            setMetaKeyDown(event.metaKey || event.ctrlKey);
        };
        const onCanvasClick = () => {
            clearSelections();
            setMetaKeyDown(false);
        };
        reakeys.useHotkeys([
            {
                name: 'Select All',
                keys: 'mod+a',
                disabled: !hotkeys.includes('selectAll'),
                category: 'Canvas',
                description: 'Select all nodes and edges',
                callback: event => {
                    event.preventDefault();
                    if (!disabled) {
                        const next = nodes.map(n => n.id);
                        onDataChange === null || onDataChange === void 0 ? void 0 : onDataChange(nodes, edges);
                        onSelection === null || onSelection === void 0 ? void 0 : onSelection(next);
                        setInternalSelections(next);
                    }
                }
            },
            {
                name: 'Delete Selections',
                category: 'Canvas',
                disabled: !hotkeys.includes('delete'),
                description: 'Delete selected nodes and edges',
                keys: 'backspace',
                callback: event => {
                    if (!disabled) {
                        event.preventDefault();
                        const result = removeNode(nodes, edges, internalSelections);
                        onDataChange === null || onDataChange === void 0 ? void 0 : onDataChange(result.nodes, result.edges);
                        onSelection === null || onSelection === void 0 ? void 0 : onSelection([]);
                        setInternalSelections([]);
                    }
                }
            },
            {
                name: 'Deselect Selections',
                category: 'Canvas',
                disabled: !hotkeys.includes('deselect'),
                description: 'Deselect selected nodes and edges',
                keys: 'escape',
                callback: event => {
                    if (!disabled) {
                        event.preventDefault();
                        onSelection === null || onSelection === void 0 ? void 0 : onSelection([]);
                        setInternalSelections([]);
                    }
                }
            }
        ]);
        return {
            onClick,
            onKeyDown,
            onCanvasClick,
            selections: internalSelections,
            clearSelections,
            addSelection,
            removeSelection,
            toggleSelection,
            setSelections: setInternalSelections
        };
    };

    const useUndo = ({ nodes, edges, disabled, maxHistory = 20, onUndoRedo }) => {
        const [canUndo, setCanUndo] = react.useState(false);
        const [canRedo, setCanRedo] = react.useState(false);
        const manager = react.useRef(new Undoo__default['default']({
            maxLength: maxHistory
        }));
        // Reference: https://reactjs.org/docs/hooks-faq.html#how-to-read-an-often-changing-value-from-usecallback
        const callbackRef = react.useRef(onUndoRedo);
        react.useEffect(() => {
            callbackRef.current = onUndoRedo;
        }, [onUndoRedo]);
        react.useEffect(() => {
            manager.current.save({
                nodes,
                edges
            });
            setCanUndo(manager.current.canUndo());
            setCanRedo(manager.current.canRedo());
        }, [nodes, edges]);
        const undo = react.useCallback(() => {
            manager.current.undo(state => {
                const nextUndo = manager.current.canUndo();
                const nextRedo = manager.current.canRedo();
                setCanUndo(nextUndo);
                setCanRedo(nextRedo);
                callbackRef.current(Object.assign(Object.assign({}, state), { type: 'undo', canUndo: nextUndo, canRedo: nextRedo }));
            });
        }, []);
        const redo = react.useCallback(() => {
            manager.current.redo(state => {
                const nextUndo = manager.current.canUndo();
                const nextRedo = manager.current.canRedo();
                setCanUndo(nextUndo);
                setCanRedo(nextRedo);
                callbackRef.current(Object.assign(Object.assign({}, state), { type: 'redo', canUndo: nextUndo, canRedo: nextRedo }));
            });
        }, []);
        const clear = react.useCallback((nodes, edges) => {
            manager.current.clear();
            setCanUndo(false);
            setCanRedo(false);
            callbackRef.current({
                type: 'clear',
                canUndo: false,
                canRedo: false
            });
            manager.current.save({
                nodes,
                edges
            });
        }, []);
        reakeys.useHotkeys([
            {
                name: 'Undo',
                keys: 'mod+z',
                category: 'Canvas',
                description: 'Undo changes',
                callback: event => {
                    event.preventDefault();
                    if (!disabled && canUndo) {
                        undo();
                    }
                }
            },
            {
                name: 'Redo',
                keys: 'mod+shift+z',
                category: 'Canvas',
                description: 'Redo changes',
                callback: event => {
                    event.preventDefault();
                    if (!disabled && canRedo) {
                        redo();
                    }
                }
            }
        ]);
        return {
            canUndo,
            canRedo,
            count: () => manager.current.count(),
            history: () => manager.current.history(),
            clear,
            redo,
            undo
        };
    };

    const buildPoints = (nodes, parent) => {
        var _a;
        const results = [];
        if (nodes === null || nodes === void 0 ? void 0 : nodes.length) {
            for (const node of nodes) {
                let x = node.x;
                let y = node.y;
                // NOTE: If we have a parent, let's update the points
                // to account for the parent's position
                if (parent) {
                    x = parent.x + x;
                    y = parent.y + y;
                }
                const points = [
                    // top-left
                    new kldAffine.Point2D(x, y),
                    // bottom-right
                    new kldAffine.Point2D(x + node.width, y + node.height)
                ];
                results.push({
                    points,
                    node
                });
                if ((_a = node.children) === null || _a === void 0 ? void 0 : _a.length) {
                    results.push(...buildPoints(node.children, node));
                }
            }
        }
        return results;
    };
    const distanceFromNode = (mousePoint, node) => {
        const [tl, br] = node.points;
        let dx = 0;
        let dy = 0;
        // Compute distance to elem in X
        if (mousePoint.x < tl.x) {
            dx = tl.x - mousePoint.x;
        }
        else if (mousePoint.x > br.x) {
            dx = br.x - mousePoint.x;
        }
        // Compute distance to elem in Y
        if (mousePoint.y < tl.y) {
            dy = tl.y - mousePoint.y;
        }
        else if (mousePoint.y > br.y) {
            dy = br.y - mousePoint.y;
        }
        return Math.floor(Math.sqrt(dx * dx + dy * dy));
    };
    const findNodeIntersection = (event, matrix, points, minDistance) => {
        const cubes = [];
        const mousePoint = new kldAffine.Point2D(event.x, event.y).transform(matrix);
        for (const point of points) {
            // TODO: Make this support other shape types...
            const intersects = kldIntersections.IntersectionQuery.pointInRectangle(mousePoint, point.points[0], point.points[1]);
            // Calc the distances
            // https://github.com/thelonious/kld-affine/issues/24
            const minDist = distanceFromNode(mousePoint, point);
            cubes.push({
                node: point.node,
                minDist,
                intersects
            });
        }
        let foundDist = minDistance;
        let intersectedNodeId = null;
        let foundNodeId = null;
        for (const cube of cubes) {
            if (cube.minDist < foundDist && !cube.intersects) {
                foundNodeId = cube.node.id;
                foundDist = cube.minDist;
            }
            if (cube.intersects) {
                intersectedNodeId = cube.node.id;
            }
        }
        if (intersectedNodeId) {
            // We are are just inside a node already
            // and there is no closer children ( nested case )
            if (!foundNodeId || foundNodeId === intersectedNodeId) {
                // If we are inside the intersected node and its the
                // closest node, let's reset the distance to 0
                foundNodeId = intersectedNodeId;
                foundDist = 0;
            }
        }
        return {
            intersectedNodeId,
            foundNodeId,
            foundDist
        };
    };
    const useProximity = (_a) => {
        var { canvasRef, disabled, minDistance = 40 } = _a, rest = __rest(_a, ["canvasRef", "disabled", "minDistance"]);
        const lastIntersectRef = react.useRef(null);
        const lastMatchRef = react.useRef(null);
        const lastDistance = react.useRef(null);
        const frame = react.useRef(0);
        // Reference: https://reactjs.org/docs/hooks-faq.html#how-to-read-an-often-changing-value-from-usecallback
        const eventRefs = react.useRef(rest);
        react.useEffect(() => {
            eventRefs.current = rest;
        }, [rest]);
        const [match, setMatch] = react.useState(null);
        const [matrix, setMatrix] = react.useState(null);
        const [points, setPoints] = react.useState(null);
        const onDragStart = react.useCallback(() => {
            if (disabled) {
                return;
            }
            const ref = canvasRef.current;
            // @ts-ignore
            setMatrix(getCoords({
                containerRef: ref.containerRef,
                zoom: ref.zoom,
                layoutXY: ref.xy
            }));
            setPoints(buildPoints(ref.layout.children));
            // eslint-disable-next-line react-hooks/exhaustive-deps
        }, [disabled]);
        const onDrag = react.useCallback((event) => {
            if (!matrix || disabled) {
                return;
            }
            const { onMatchChange, onIntersects, onDistanceChange } = eventRefs.current;
            const { intersectedNodeId, foundNodeId, foundDist } = findNodeIntersection(event, matrix, points, minDistance);
            const nextDist = foundDist !== minDistance ? foundDist : null;
            if (foundNodeId !== lastMatchRef.current) {
                onMatchChange === null || onMatchChange === void 0 ? void 0 : onMatchChange(foundNodeId, foundDist);
            }
            if (intersectedNodeId !== lastIntersectRef.current) {
                onIntersects === null || onIntersects === void 0 ? void 0 : onIntersects(intersectedNodeId);
            }
            if (onDistanceChange && nextDist !== lastDistance.current) {
                cancelAnimationFrame(frame.current);
                frame.current = requestAnimationFrame(() => {
                    onDistanceChange(nextDist);
                });
            }
            // Hold these in refs for race cases
            lastIntersectRef.current = intersectedNodeId;
            lastMatchRef.current = foundNodeId;
            lastDistance.current = nextDist;
            setMatch(foundNodeId);
        }, [matrix, disabled, minDistance, points]);
        react.useEffect(() => {
            return () => cancelAnimationFrame(frame.current);
        });
        const onDragEnd = react.useCallback(() => {
            if (!disabled) {
                setMatch(null);
                setMatrix(null);
                setPoints(null);
            }
        }, [disabled]);
        return {
            match,
            onDragStart,
            onDrag,
            onDragEnd
        };
    };

    /**
     * Helper function to determine if edge already has a link.
     */
    function hasLink(edges, from, to) {
        return edges.some((e) => e.from === from.id && e.to === to.id);
    }
    /**
     * Get sources pointing to a node.
     */
    function getSourceNodesForTargetId(nodes, edges, nodeId) {
        const sourceNodeIds = edges.reduce((acc, edge) => {
            if (edge.to === nodeId) {
                acc.push(edge.from);
            }
            return acc;
        }, []);
        const node = nodes.find((n) => n.id === nodeId);
        if (node === null || node === void 0 ? void 0 : node.parent) {
            sourceNodeIds.push(node.parent);
        }
        return nodes.filter((n) => sourceNodeIds.includes(n.id));
    }
    /**
     * Detect if there is a circular reference from the from to the source node.
     */
    function detectCircular(nodes, edges, fromNode, toNode) {
        let found = false;
        const traverse = (nodeId) => {
            const sourceNodes = getSourceNodesForTargetId(nodes, edges, nodeId);
            for (const node of sourceNodes) {
                if (node.id !== toNode.id) {
                    traverse(node.id);
                }
                else {
                    found = true;
                    break;
                }
            }
        };
        traverse(fromNode.id);
        return found;
    }
    /**
     * Given a node id, get all the parent nodes recursively.
     */
    const getParentsForNodeId = (nodes, edges, startId) => {
        const result = [];
        const traverse = (nodeId) => {
            const sourceNodes = getSourceNodesForTargetId(nodes, edges, nodeId);
            for (const node of sourceNodes) {
                const has = result.find((n) => n.id === node.id);
                if (!has) {
                    result.push(node);
                    traverse(node.id);
                }
            }
        };
        traverse(startId);
        return result;
    };
    /**
     * Get edge data given a node.
     */
    function getEdgesByNode(edges, node) {
        const to = [];
        const from = [];
        for (const edge of edges) {
            if (edge.to === node.id) {
                to.push(edge);
            }
            if (edge.from === node.id) {
                from.push(edge);
            }
        }
        return {
            to,
            from,
            all: [...to, ...from]
        };
    }

    exports.Add = Add;
    exports.Arrow = Arrow;
    exports.Canvas = Canvas;
    exports.CanvasContext = CanvasContext;
    exports.CanvasProvider = CanvasProvider;
    exports.Edge = Edge;
    exports.Icon = Icon;
    exports.Label = Label;
    exports.MarkerArrow = MarkerArrow;
    exports.Node = Node;
    exports.Port = Port;
    exports.Remove = Remove;
    exports.addNodeAndEdge = addNodeAndEdge;
    exports.checkNodeLinkable = checkNodeLinkable;
    exports.createEdgeFromNodes = createEdgeFromNodes;
    exports.detectCircular = detectCircular;
    exports.elkLayout = elkLayout;
    exports.findNestedNode = findNestedNode;
    exports.formatText = formatText;
    exports.getCoords = getCoords;
    exports.getDragNodeData = getDragNodeData;
    exports.getEdgesByNode = getEdgesByNode;
    exports.getParentsForNodeId = getParentsForNodeId;
    exports.hasLink = hasLink;
    exports.measureText = measureText;
    exports.parsePadding = parsePadding;
    exports.removeAndUpsertNodes = removeAndUpsertNodes;
    exports.removeEdge = removeEdge;
    exports.removeEdgesFromNode = removeEdgesFromNode;
    exports.removeNode = removeNode;
    exports.upsertNode = upsertNode;
    exports.useCanvas = useCanvas;
    exports.useEdgeDrag = useEdgeDrag;
    exports.useLayout = useLayout;
    exports.useNodeDrag = useNodeDrag;
    exports.useProximity = useProximity;
    exports.useSelection = useSelection;
    exports.useUndo = useUndo;
    exports.useZoom = useZoom;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
